OGRE-Next: Ogre::Camera Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::Camera Class Reference
Core | Component » Scene

A viewpoint from which the scene will be rendered. More...

`#include <OgreCamera.h>`

Inheritance diagram for Ogre::Camera:
[legend]

## Classes
class | Listener
| Listener interface so you can be notified of Camera events. More...

## Public Types
enum | CameraSortMode { SortModeDistance , SortModeDepth , SortModeDistanceRadiusIgnoring , SortModeDepthRadiusIgnoring }
| Sets how the objects are sorted. More...
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap

## Public Member Functions
| Camera (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *sm)
| Standard constructor.
| ~Camera () override
| Standard destructor.
void | _autoTrack ()
| Internal method used by OGRE to update auto-tracking cameras.
void | _cullScenePhase01 (Camera *renderCamera, const Camera *lodCamera, Viewport *vp, uint8 firstRq, uint8 lastRq, bool reuseCullData)
| Tells the Camera to contact the SceneManager to render from it's viewpoint.
const Quaternion & | _getCachedDerivedOrientation () const
const Vector3 & | _getCachedDerivedPosition () const
| Same as getDerivedPosition, but doesn't check if dirty.
const Quaternion & | _getCachedRealOrientation () const
const Vector3 & | _getCachedRealPosition () const
float | _getConstantBiasScale () const
Real | _getLodBiasInverse () const
| Internal method for OGRE to use for LOD calculations.
size_t | _getNumRenderedBatches () const
| Internal method to retrieve the number of visible batches in the last render.
size_t | _getNumRenderedFaces () const
| Internal method to retrieve the number of visible faces in the last render.
const RenderingMetrics & | _getRenderingMetrics () const
| Internal method to retrieve the number of visible faces, batches, etc in the last render.
void | _notifyRenderingMetrics (const RenderingMetrics &metrics)
| Internal method to notify camera of the visible faces in the last render.
void | _notifyViewport (Viewport *viewport)
| Notifies this camera that a viewport is using it.
void | _renderScenePhase02 (const Camera *lodCamera, uint8 firstRq, uint8 lastRq, bool includeOverlays)
void | _setConstantBiasScale (const float bias)
void | _setNeedsDepthClamp (bool bNeedsDepthClamp)
virtual void | addListener (Listener *l)
| Add a listener to this camera.
virtual void | forwardIntersect (const Plane &worldPlane, vector< Vector4 >::type *intersect3d) const
| Forward projects frustum rays to find forward intersection with plane.
bool | getAutoAspectRatio () const
| Retrieves if AutoAspectRatio is currently set or not.
const Vector3 & | getAutoTrackOffset () const
| Get the auto tracking offset for this camera, if it is auto tracking.
SceneNode * | getAutoTrackTarget () const
| Get the auto tracking target for this camera, if any.
PlaneBoundedVolume | getCameraToViewportBoxVolume (Real screenLeft, Real screenTop, Real screenRight, Real screenBottom, bool includeFarPlane=false)
| Gets a world-space list of planes enclosing a volume based on a viewport rectangle.
void | getCameraToViewportBoxVolume (Real screenLeft, Real screenTop, Real screenRight, Real screenBottom, PlaneBoundedVolume *outVolume, bool includeFarPlane=false)
| Gets a world-space list of planes enclosing a volume based on a viewport rectangle.
Ray | getCameraToViewportRay (Real screenx, Real screeny) const
| Gets a world space ray as cast from the camera through a viewport position.
void | getCameraToViewportRay (Real screenx, Real screeny, Ray *outRay) const
| Gets a world space ray as cast from the camera through a viewport position.
Frustum * | getCullingFrustum () const
| Returns the custom culling frustum in use.
Vector3 | getDerivedDirection () const
| Gets the derived direction vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
const Quaternion & | getDerivedOrientation () const
| Gets the derived orientation of the camera, including any rotation inherited from a node attachment and reflection matrix.
const Vector3 & | getDerivedPosition () const
| Gets the derived position of the camera, including any translation inherited from a node attachment and reflection matrix.
Vector3 | getDerivedRight () const
| Gets the derived right vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
Vector3 | getDerivedUp () const
| Gets the derived up vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
Vector3 | getDirection () const
| Gets the camera's direction.
Real | getFarClipDistance () const override
| Retrieves the distance from the frustum to the far clipping plane.
const Plane & | getFrustumPlane (unsigned short plane) const override
| Retrieves a specified plane of the frustum (world space).
Viewport * | getLastViewport () const
| Get the last viewport which was attached to this camera.
Real | getLodBias () const
| Returns the level-of-detail bias factor currently applied to this camera.
virtual const Camera * | getLodCamera () const
| Get a pointer to the camera which should be used to determine LOD settings.
const String & | getMovableType () const override
| Overridden from MovableObject.
Real | getNearClipDistance () const override
| Sets the position of the near clipping plane.
bool | getNeedsDepthClamp () const
const Quaternion & | getOrientation () const
| Returns the camera's current orientation.
const Quaternion & | getOrientationForViewUpdate () const override
| Get the derived orientation of this frustum.
Real | getPixelDisplayRatio () const
| Returns an estimated ratio between a pixel and the display area it represents.
const Vector3 & | getPosition () const
| Retrieves the camera's position.
const Vector3 & | getPositionForViewUpdate () const override
| Get the derived position of this frustum.
Vector3 | getRealDirection () const
| Gets the real world direction vector of the camera, including any rotation inherited from a node attachment.
const Quaternion & | getRealOrientation () const
| Gets the real world orientation of the camera, including any rotation inherited from a node attachment.
const Vector3 & | getRealPosition () const
| Gets the real world position of the camera, including any translation inherited from a node attachment.
Vector3 | getRealRight () const
| Gets the real world right vector of the camera, including any rotation inherited from a node attachment.
Vector3 | getRealUp () const
| Gets the real world up vector of the camera, including any rotation inherited from a node attachment.
Vector3 | getRight () const
| Gets the camera's right vector.
SceneManager * | getSceneManager () const
| Returns a pointer to the SceneManager this camera is rendering through.
Vector3 | getUp () const
| Gets the camera's up vector.
bool | getUseMinPixelSize () const
| Returns whether to use min display size calculations.
virtual bool | getUseRenderingDistance () const
| Get whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.
const Matrix4 & | getViewMatrix () const override
| Gets the view matrix for this frustum.
const Matrix4 & | getViewMatrix (bool ownFrustumOnly) const
| Specialised version of getViewMatrix allowing caller to differentiate whether the custom culling frustum should be allowed or not.
const VrData * | getVrData () const
Matrix4 | getVrProjectionMatrix (size_t eyeIdx) const
Matrix4 | getVrViewMatrix (size_t eyeIdx) const
const PlaneList & | getWindowPlanes () const
| Gets the window clip planes, only applicable if isWindowSet == true.
const Vector3 * | getWorldSpaceCorners () const override
| Gets the world space corners of the frustum.
void | getWorldTransforms (Matrix4 *mat) const override
| Overridden from Frustum/Renderable.
bool | isVisible (const AxisAlignedBox &bound, FrustumPlane *culledBy=0) const override
| Tests whether the given container is visible in the Frustum.
bool | isVisible (const Sphere &bound, FrustumPlane *culledBy=0) const override
| Tests whether the given container is visible in the Frustum.
bool | isVisible (const Vector3 &vert, FrustumPlane *culledBy=0) const override
| Tests whether the given vertex is visible in the Frustum.
virtual bool | isWindowSet () const
| Returns if a viewport window is being used.
void | lookAt (const Vector3 &targetPoint)
| Points the camera at a location in worldspace.
void | lookAt (Real x, Real y, Real z)
| Points the camera at a location in worldspace.
void | move (const Vector3 &vec)
| Moves the camera's position by the vector offset provided along world axes.
void | moveRelative (const Vector3 &vec)
| Moves the camera's position by the vector offset provided along it's own axes (relative to orientation).
void | pitch (const Radian &angle)
| Pitches the camera up/down anticlockwise around it's local z axis.
bool | projectSphere (const Sphere &sphere, Real *left, Real *top, Real *right, Real *bottom) const override
| Project a sphere onto the near plane and get the bounding rectangle.
virtual void | removeListener (Listener *l)
| Remove a listener to this camera.
virtual void | resetWindow ()
| Cancel view window.
void | roll (const Radian &angle)
| Rolls the camera anticlockwise, around its local z axis.
void | rotate (const Quaternion &q)
| Rotate the camera around an arbitrary axis using a Quaternion.
void | rotate (const Vector3 &axis, const Radian &angle)
| Rotate the camera around an arbitrary axis.
void | setAutoAspectRatio (bool autoratio)
| If set to true a viewport that owns this frustum will be able to recalculate the aspect ratio whenever the frustum is resized.
void | setAutoTracking (bool enabled, SceneNode *const target=0, const Vector3 &offset=Vector3::ZERO)
| Enables / disables automatic tracking of a SceneNode.
void | setCullingFrustum (Frustum *frustum)
| Tells the camera to use a separate Frustum instance to perform culling.
void | setDirection (const Vector3 &vec)
| Sets the camera's direction vector.
void | setDirection (Real x, Real y, Real z)
| Sets the camera's direction vector.
void | setFixedYawAxis (bool useFixed, const Vector3 &fixedAxis=Vector3::UNIT_Y)
| Tells the camera whether to yaw around it's own local Y axis or a fixed axis of choice.
void | setLightCullingVisibility (bool collectLights, bool isCubemap)
| When a camera is created via SceneManager::createCamera, there are two additional parameters.
void | setLodBias (Real factor=1.0)
| Sets the level-of-detail factor for this Camera.
virtual void | setLodCamera (const Camera *lodCam)
| Set a pointer to the camera which should be used to determine LOD settings.
void | setOrientation (const Quaternion &q)
| Sets the camera's orientation.
void | setPosition (const Vector3 &vec)
| Sets the camera's position.
void | setPosition (Real x, Real y, Real z)
| Sets the camera's position.
void | setUseMinPixelSize (bool enable)
| Sets whether to use min display size calculations.
virtual void | setUseRenderingDistance (bool use)
| Set whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.
void | setVrData (VrData *vrData)
| Sets VR data for calculating left & right eyes See OpenVR sample for more info.
virtual void | setWindow (Real left, Real top, Real right, Real bottom)
| Sets the viewing window inside of viewport.
virtual void | synchroniseBaseSettingsWith (const Camera *cam)
| Synchronise core camera settings with another.
void | yaw (const Radian &angle)
| Rotates the camera anticlockwise around it's local y axis.
Public Member Functions inherited from Ogre::Frustum
| Frustum (IdType id, ObjectMemoryManager *objectMemoryManager)
| Named constructor.
| ~Frustum () override
const Plane * | _getCachedFrustumPlanes () const
| Returns the frustum planes, doesn't check if dirty.
const Vector3 * | _getCachedWorldSpaceCorners () const
virtual void | calcViewMatrixRelative (const Vector3 &relPos, Matrix4 &matToUpdate) const
| Calculate a view matrix for this frustum, relative to a potentially dynamic point.
virtual void | disableCustomNearClipPlane ()
| Disables any custom near clip plane.
virtual void | disableReflection ()
| Disables reflection modification previously turned on with enableReflection.
virtual void | enableCustomNearClipPlane (const MovablePlane *plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.
virtual void | enableCustomNearClipPlane (const Plane &plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.
virtual void | enableReflection (const MovablePlane *p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified.
virtual void | enableReflection (const Plane &p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified.
virtual Real | getAspectRatio () const
| Retrieves the current aspect ratio.
const AxisAlignedBox & | getBoundingBox () const
| Overridden from MovableObject.
void | getCustomWorldSpaceCorners (ArrayVector3 outCorners[(8+ARRAY_PACKED_REALS - 1)/ARRAY_PACKED_REALS], Real customFarPlane) const
virtual Real | getFocalLength () const
| Returns focal length of frustum.
virtual const Radian & | getFOVy () const
| Retrieves the frustums Y-dimension Field Of View (FOV).
virtual void | getFrustumExtents (Real &outleft, Real &outright, Real &outtop, Real &outbottom, FrustrumExtentsType frustrumExtentsType=FET_PROJ_PLANE_POS) const
| Get the extents of the frustum in view space.
bool | getFrustumExtentsManuallySet () const
virtual const Vector2 & | getFrustumOffset () const
| Retrieves the frustum offsets.
const Plane * | getFrustumPlanes () const
| Retrieves the clipping planes of the frustum (world space).
const LightList & | getLights () const override
| Overridden from Renderable.
const String & | getMovableType () const override
| Overridden from MovableObject.
OrientationMode | getOrientationMode () const
| Get the orientation mode of the frustum.
Radian | getOrientationModeAngle () const
| Get the orientation mode angle of the frustum.
virtual Real | getOrthoWindowHeight () const
| Gets the orthographic window height, for use with orthographic rendering only.
virtual Real | getOrthoWindowWidth () const
| Gets the orthographic window width, for use with orthographic rendering only.
PlaneBoundedVolume | getPlaneBoundedVolume ()
| Gets a world-space list of planes enclosing the frustum.
virtual const Matrix4 & | getProjectionMatrix () const
| Gets the normal projection matrix for this frustum, ie the projection matrix which conforms to standard right-handed rules and uses depth range [-1,+1].
virtual const Matrix4 & | getProjectionMatrixWithRSDepth () const
| Gets the depth-adjusted projection matrix for the current rendersystem, but one which still conforms to right-hand rules.
Vector2 | getProjectionParamsAB () const
| Returns the terms projectionA and projectionB in .x and .y respectively, which can be used to reconstruct linear depth from a Z buffer.
virtual ProjectionType | getProjectionType () const
| Retrieves info on the type of projection used (orthographic or perspective).
virtual const Matrix4 & | getReflectionMatrix () const
| Returns the reflection matrix of the frustum if appropriate.
virtual const Plane & | getReflectionPlane () const
| Returns the reflection plane of the frustum if appropriate.
void | getRenderOperation (v1::RenderOperation &op, bool casterPass) override
| Overridden from Renderable.
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden from Renderable.
void | getWorldTransforms (Matrix4 *xform) const override
| Overridden from Renderable.
virtual bool | isCustomNearClipPlaneEnabled () const
| Is a custom near clip plane in use?
virtual bool | isCustomProjectionMatrixEnabled () const
| Returns whether a custom projection matrix is in use.
virtual bool | isCustomViewMatrixEnabled () const
| Returns whether a custom view matrix is in use.
virtual bool | isReflected () const
| Returns whether this frustum is being reflected.
virtual void | resetFrustumExtents ()
| Reset the frustum extents to be automatically derived from other params.
virtual void | setAspectRatio (Real ratio)
| Sets the aspect ratio for the frustum viewport.
virtual void | setCustomProjectionMatrix (bool enable, const Matrix4 &projectionMatrix=Matrix4::IDENTITY, bool alternateDepthRange=false)
| Set whether to use a custom projection matrix on this frustum.
virtual void | setCustomViewMatrix (bool enable, const Matrix4 &viewMatrix=Matrix4::IDENTITY)
| Set whether to use a custom view matrix on this frustum.
virtual void | setFarClipDistance (Real farDist)
| Sets the distance to the far clipping plane.
virtual void | setFocalLength (Real focalLength=1.0)
| Sets frustum focal length (used in stereo rendering).
virtual void | setFOVy (const Radian &fovy)
| Sets the Y-dimension Field Of View (FOV) of the frustum.
virtual void | setFrustumExtents (Real left, Real right, Real top, Real bottom, FrustrumExtentsType frustrumExtentsType=FET_PROJ_PLANE_POS)
| Manually set the extents of the frustum.
virtual void | setFrustumOffset (const Vector2 &offset)
| Sets frustum offsets, used in stereo rendering.
virtual void | setFrustumOffset (Real horizontal=0.0, Real vertical=0.0)
| Sets frustum offsets, used in stereo rendering.
virtual void | setNearClipDistance (Real nearDist)
| Sets the position of the near clipping plane.
void | setOrientationMode (OrientationMode orientationMode)
| Set the orientation mode of the frustum.
virtual void | setOrthoWindow (Real w, Real h)
| Sets the orthographic window settings, for use with orthographic rendering only.
virtual void | setOrthoWindowHeight (Real h)
| Sets the orthographic window height, for use with orthographic rendering only.
virtual void | setOrthoWindowWidth (Real w)
| Sets the orthographic window width, for use with orthographic rendering only.
virtual void | setProjectionType (ProjectionType pt)
| Sets the type of projection to use (orthographic or perspective).
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only)
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only)
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum()
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum()
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Static Public Member Functions
static CameraSortMode | getDefaultSortMode ()
static void | setDefaultSortMode (CameraSortMode sortMode)
| Sets the default sort mode for all future Camera instances.
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.

## Public Attributes
CameraSortMode | mSortMode
| PUBLIC VARIABLE.
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.

## Additional Inherited Members
Static Public Attributes inherited from Ogre::Frustum
static const Real | INFINITE_FAR_PLANE_ADJUST
| Small constant used to reduce far plane projection to avoid inaccuracies.
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

A viewpoint from which the scene will be rendered.

Remarks
  OGRE renders scenes from a camera viewpoint into a buffer of some sort, normally a window or a texture (a subclass of RenderTarget). OGRE cameras support both perspective projection (the default, meaning objects get smaller the further away they are) and orthographic projection (blueprint-style, no decrease in size with distance). Each camera carries with it a style of rendering, e.g. full textured, flat shaded, wireframe), field of view, rendering distances etc, allowing you to use OGRE to create complex multi-window views if required. In addition, more than one camera can point at a single render target if required, each rendering to a subset of the target, allowing split screen and picture-in-picture views.

  Cameras maintain their own aspect ratios, field of view, and frustum, and project co-ordinates into a space measured from -1 to 1 in x and y, and 0 to 1 in z. At render time, the camera will be rendering to a Viewport which will translate these parametric co-ordinates into real screen co-ordinates. Obviously it is advisable that the viewport has the same aspect ratio as the camera to avoid distortion (unless you want it!).

  Starting Ogre 2.x, a Camera must be attached to a SceneNode, using the method SceneNode::attachObject. By default the camera is attached to the root scene node on creation. When this is done the Camera will combine it's own position/orientation settings with it's parent SceneNode. This is also useful for implementing more complex Camera / object relationships i.e. having a camera attached to a world object.

## Member Enumeration Documentation

## ◆ CameraSortMode

enum Ogre::Camera::CameraSortMode

Sets how the objects are sorted.

This affects both opaque (performance optimization, rendered front to back) and transparents (visual correctness, rendered back to front)

Object sorting is approximate, and some scenes are suited to different modes depending on the objects' geometric properties

See https://forums.ogre3d.org/viewtopic.php?f=2&t=94090 for examples

Please note that RenderQueue::addRenderable quantizes the final depth value. Therefore if two objects are numerically very close, the chosen mode may not make too much of a difference.

Enumerator
SortModeDistance | Sort objects by distance to camera. i.e. cameraPos.distance( objPos ) - objRadius The bigger the object radius, the closer it is considered to be to the camera
SortModeDepth | Sort objects by depth i.e. objViewSpacePos.z - objRadius The bigger the object radius, the closer it is considered to be to the camera
SortModeDistanceRadiusIgnoring | Same as SortModeDistance, but skips object radius from calculations.
SortModeDepthRadiusIgnoring | Same as SortModeDepth, but skips object radius from calculations.

## Constructor & Destructor Documentation

## ◆ Camera()

Ogre::Camera::Camera | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | sm )

Standard constructor.

Referenced by _cullScenePhase01(), _renderScenePhase02(), Ogre::Camera::Listener::cameraDestroyed(), Ogre::Camera::Listener::cameraPostRenderScene(), Ogre::Camera::Listener::cameraPreRenderScene(), getLodCamera(), operator<<, setLodCamera(), and synchroniseBaseSettingsWith().

## ◆ ~Camera()

Ogre::Camera::~Camera | ( |  | ) |
| override

Standard destructor.

## Member Function Documentation

## ◆ _autoTrack()

void Ogre::Camera::_autoTrack | ( |  | ) |

Internal method used by OGRE to update auto-tracking cameras.

## ◆ _cullScenePhase01()

void Ogre::Camera::_cullScenePhase01 | ( | Camera * | renderCamera,
|  | const Camera * | lodCamera,
|  | Viewport * | vp,
|  | uint8 | firstRq,
|  | uint8 | lastRq,
|  | bool | reuseCullData )

Tells the Camera to contact the SceneManager to render from it's viewpoint.

Parameters

  vp | The viewport to render to
  includeOverlays | Whether or not any overlay objects should be included
  firstRq | First RenderQueue ID to render (inclusive)
  lastRq | Last RenderQueue ID to render (exclusive)

References Camera().

## ◆ _getCachedDerivedOrientation()

const Quaternion & Ogre::Camera::_getCachedDerivedOrientation | ( |  | ) | const
| inline

## ◆ _getCachedDerivedPosition()

const Vector3 & Ogre::Camera::_getCachedDerivedPosition | ( |  | ) | const
| inline

Same as getDerivedPosition, but doesn't check if dirty.

## ◆ _getCachedRealOrientation()

const Quaternion & Ogre::Camera::_getCachedRealOrientation | ( |  | ) | const
| inline

## ◆ _getCachedRealPosition()

const Vector3 & Ogre::Camera::_getCachedRealPosition | ( |  | ) | const
| inline

## ◆ _getConstantBiasScale()

float Ogre::Camera::_getConstantBiasScale | ( |  | ) | const
| inline

## ◆ _getLodBiasInverse()

Real Ogre::Camera::_getLodBiasInverse | ( |  | ) | const

Internal method for OGRE to use for LOD calculations.

## ◆ _getNumRenderedBatches()

size_t Ogre::Camera::_getNumRenderedBatches | ( |  | ) | const

Internal method to retrieve the number of visible batches in the last render.

Deprecated
  use Camera::_getRenderingMetrics() instead.

## ◆ _getNumRenderedFaces()

size_t Ogre::Camera::_getNumRenderedFaces | ( |  | ) | const

Internal method to retrieve the number of visible faces in the last render.

Deprecated
  use Camera::_getRenderingMetrics() instead.

## ◆ _getRenderingMetrics()

const RenderingMetrics & Ogre::Camera::_getRenderingMetrics | ( |  | ) | const

Internal method to retrieve the number of visible faces, batches, etc in the last render.

## ◆ _notifyRenderingMetrics()

void Ogre::Camera::_notifyRenderingMetrics | ( | const RenderingMetrics & | metrics | ) |

Internal method to notify camera of the visible faces in the last render.

## ◆ _notifyViewport()

void Ogre::Camera::_notifyViewport | ( | Viewport * | viewport | ) |
| inline

Notifies this camera that a viewport is using it.

## ◆ _renderScenePhase02()

void Ogre::Camera::_renderScenePhase02 | ( | const Camera * | lodCamera,
|  | uint8 | firstRq,
|  | uint8 | lastRq,
|  | bool | includeOverlays )

References Camera().

## ◆ _setConstantBiasScale()

void Ogre::Camera::_setConstantBiasScale | ( | const float | bias | ) |
| inline

## ◆ _setNeedsDepthClamp()

void Ogre::Camera::_setNeedsDepthClamp | ( | bool | bNeedsDepthClamp | ) |

## ◆ addListener()

virtual void Ogre::Camera::addListener | ( | Listener * | l | ) |
| virtual

Add a listener to this camera.

## ◆ forwardIntersect()

virtual void Ogre::Camera::forwardIntersect | ( | const Plane & | worldPlane,
|  | vector< Vector4 >::type * | intersect3d ) const
| virtual

Forward projects frustum rays to find forward intersection with plane.

Remarks
  Forward projection may lead to intersections at infinity.

## ◆ getAutoAspectRatio()

bool Ogre::Camera::getAutoAspectRatio | ( |  | ) | const

Retrieves if AutoAspectRatio is currently set or not.

## ◆ getAutoTrackOffset()

const Vector3 & Ogre::Camera::getAutoTrackOffset | ( |  | ) | const
| inline

Get the auto tracking offset for this camera, if it is auto tracking.

## ◆ getAutoTrackTarget()

SceneNode * Ogre::Camera::getAutoTrackTarget | ( |  | ) | const
| inline

Get the auto tracking target for this camera, if any.

## ◆ getCameraToViewportBoxVolume() [1/2]

PlaneBoundedVolume Ogre::Camera::getCameraToViewportBoxVolume | ( | Real | screenLeft,
|  | Real | screenTop,
|  | Real | screenRight,
|  | Real | screenBottom,
|  | bool | includeFarPlane = false )

Gets a world-space list of planes enclosing a volume based on a viewport rectangle.

Remarks
  Can be useful for populating a PlaneBoundedVolumeListSceneQuery, e.g. for a rubber-band selection.

Parameters

  screenLeft,screenTop,screenRight,screenBottom | The bounds of the on-screen rectangle, expressed in normalised screen coordinates [0,1]
  includeFarPlane | If true, the volume is truncated by the camera far plane, by default it is left open-ended

## ◆ getCameraToViewportBoxVolume() [2/2]

void Ogre::Camera::getCameraToViewportBoxVolume | ( | Real | screenLeft,
|  | Real | screenTop,
|  | Real | screenRight,
|  | Real | screenBottom,
|  | PlaneBoundedVolume * | outVolume,
|  | bool | includeFarPlane = false )

Gets a world-space list of planes enclosing a volume based on a viewport rectangle.

Remarks
  Can be useful for populating a PlaneBoundedVolumeListSceneQuery, e.g. for a rubber-band selection.

Parameters

  screenLeft,screenTop,screenRight,screenBottom | The bounds of the on-screen rectangle, expressed in normalised screen coordinates [0,1]
  outVolume | The plane list to populate with the result
  includeFarPlane | If true, the volume is truncated by the camera far plane, by default it is left open-ended

## ◆ getCameraToViewportRay() [1/2]

Ray Ogre::Camera::getCameraToViewportRay | ( | Real | screenx,
|  | Real | screeny ) const

Gets a world space ray as cast from the camera through a viewport position.

Parameters

  screenx,screeny | The x and y position at which the ray should intersect the viewport, in normalised screen coordinates [0,1]

## ◆ getCameraToViewportRay() [2/2]

void Ogre::Camera::getCameraToViewportRay | ( | Real | screenx,
|  | Real | screeny,
|  | Ray * | outRay ) const

Gets a world space ray as cast from the camera through a viewport position.

Parameters

  screenx,screeny | The x and y position at which the ray should intersect the viewport, in normalised screen coordinates [0,1]
  outRay | Ray instance to populate with result

## ◆ getCullingFrustum()

Frustum * Ogre::Camera::getCullingFrustum | ( |  | ) | const
| inline

Returns the custom culling frustum in use.

References Ogre::Frustum::Frustum().

## ◆ getDefaultSortMode()

static CameraSortMode Ogre::Camera::getDefaultSortMode | ( |  | ) |
| inlinestatic

## ◆ getDerivedDirection()

Vector3 Ogre::Camera::getDerivedDirection | ( |  | ) | const

Gets the derived direction vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedOrientation()

const Quaternion & Ogre::Camera::getDerivedOrientation | ( |  | ) | const

Gets the derived orientation of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedPosition()

const Vector3 & Ogre::Camera::getDerivedPosition | ( |  | ) | const

Gets the derived position of the camera, including any translation inherited from a node attachment and reflection matrix.

## ◆ getDerivedRight()

Vector3 Ogre::Camera::getDerivedRight | ( |  | ) | const

Gets the derived right vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedUp()

Vector3 Ogre::Camera::getDerivedUp | ( |  | ) | const

Gets the derived up vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDirection()

Vector3 Ogre::Camera::getDirection | ( |  | ) | const

Gets the camera's direction.

## ◆ getFarClipDistance()

Real Ogre::Camera::getFarClipDistance | ( |  | ) | const
| overridevirtual

Retrieves the distance from the frustum to the far clipping plane.

Reimplemented from Ogre::Frustum.

## ◆ getFrustumPlane()

const Plane & Ogre::Camera::getFrustumPlane | ( | unsigned short | plane | ) | const
| overridevirtual

Retrieves a specified plane of the frustum (world space).

Remarks
  Gets a reference to one of the planes which make up the frustum frustum, e.g. for clipping purposes.

Reimplemented from Ogre::Frustum.

## ◆ getLastViewport()

Viewport * Ogre::Camera::getLastViewport | ( |  | ) | const
| inline

Get the last viewport which was attached to this camera.

Note
  This is not guaranteed to be the only viewport which is using this camera, just the last once which was created referring to it.

## ◆ getLodBias()

Real Ogre::Camera::getLodBias | ( |  | ) | const

Returns the level-of-detail bias factor currently applied to this camera.

Remarks
  See Camera::setLodBias for more details.

## ◆ getLodCamera()

virtual const Camera * Ogre::Camera::getLodCamera | ( |  | ) | const
| virtual

Get a pointer to the camera which should be used to determine LOD settings.

Remarks
  If setLodCamera hasn't been called with a different camera, this method will return 'this'.

References Camera().

## ◆ getMovableType()

const String & Ogre::Camera::getMovableType | ( |  | ) | const
| overridevirtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ getNearClipDistance()

Real Ogre::Camera::getNearClipDistance | ( |  | ) | const
| overridevirtual

Sets the position of the near clipping plane.

Reimplemented from Ogre::Frustum.

## ◆ getNeedsDepthClamp()

bool Ogre::Camera::getNeedsDepthClamp | ( |  | ) | const
| inline

## ◆ getOrientation()

const Quaternion & Ogre::Camera::getOrientation | ( |  | ) | const

Returns the camera's current orientation.

## ◆ getOrientationForViewUpdate()

const Quaternion & Ogre::Camera::getOrientationForViewUpdate | ( |  | ) | const
| overridevirtual

Get the derived orientation of this frustum.

Reimplemented from Ogre::Frustum.

## ◆ getPixelDisplayRatio()

Real Ogre::Camera::getPixelDisplayRatio | ( |  | ) | const
| inline

Returns an estimated ratio between a pixel and the display area it represents.

For orthographic cameras this function returns the amount of meters covered by a single pixel along the vertical axis. For perspective cameras the value returned is the amount of meters covered by a single pixel per meter distance from the camera.

Note
  This parameter is calculated just before the camera is rendered
  This parameter is used in min display size calculations.

## ◆ getPosition()

const Vector3 & Ogre::Camera::getPosition | ( |  | ) | const

Retrieves the camera's position.

## ◆ getPositionForViewUpdate()

const Vector3 & Ogre::Camera::getPositionForViewUpdate | ( |  | ) | const
| overridevirtual

Get the derived position of this frustum.

Reimplemented from Ogre::Frustum.

## ◆ getRealDirection()

Vector3 Ogre::Camera::getRealDirection | ( |  | ) | const

Gets the real world direction vector of the camera, including any rotation inherited from a node attachment.

## ◆ getRealOrientation()

const Quaternion & Ogre::Camera::getRealOrientation | ( |  | ) | const

Gets the real world orientation of the camera, including any rotation inherited from a node attachment.

## ◆ getRealPosition()

const Vector3 & Ogre::Camera::getRealPosition | ( |  | ) | const

Gets the real world position of the camera, including any translation inherited from a node attachment.

## ◆ getRealRight()

Vector3 Ogre::Camera::getRealRight | ( |  | ) | const

Gets the real world right vector of the camera, including any rotation inherited from a node attachment.

## ◆ getRealUp()

Vector3 Ogre::Camera::getRealUp | ( |  | ) | const

Gets the real world up vector of the camera, including any rotation inherited from a node attachment.

## ◆ getRight()

Vector3 Ogre::Camera::getRight | ( |  | ) | const

Gets the camera's right vector.

## ◆ getSceneManager()

SceneManager * Ogre::Camera::getSceneManager | ( |  | ) | const

Returns a pointer to the SceneManager this camera is rendering through.

## ◆ getUp()

Vector3 Ogre::Camera::getUp | ( |  | ) | const

Gets the camera's up vector.

## ◆ getUseMinPixelSize()

bool Ogre::Camera::getUseMinPixelSize | ( |  | ) | const
| inline

Returns whether to use min display size calculations.

See also
  Camera::setUseMinDisplaySize

## ◆ getUseRenderingDistance()

virtual bool Ogre::Camera::getUseRenderingDistance | ( |  | ) | const
| inlinevirtual

Get whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.

## ◆ getViewMatrix() [1/2]

const Matrix4 & Ogre::Camera::getViewMatrix | ( |  | ) | const
| overridevirtual

Gets the view matrix for this frustum.

Mainly for use by OGRE internally.

Reimplemented from Ogre::Frustum.

## ◆ getViewMatrix() [2/2]

const Matrix4 & Ogre::Camera::getViewMatrix | ( | bool | ownFrustumOnly | ) | const

Specialised version of getViewMatrix allowing caller to differentiate whether the custom culling frustum should be allowed or not.

Remarks
  The default behaviour of the standard getViewMatrix is to delegate to the alternate culling frustum, if it is set. This is expected when performing CPU calculations, but the final rendering must be performed using the real view matrix in order to display the correct debug view.

## ◆ getVrData()

const VrData * Ogre::Camera::getVrData | ( |  | ) | const
| inline

## ◆ getVrProjectionMatrix()

Matrix4 Ogre::Camera::getVrProjectionMatrix | ( | size_t | eyeIdx | ) | const

## ◆ getVrViewMatrix()

Matrix4 Ogre::Camera::getVrViewMatrix | ( | size_t | eyeIdx | ) | const

## ◆ getWindowPlanes()

const PlaneList & Ogre::Camera::getWindowPlanes | ( |  | ) | const

Gets the window clip planes, only applicable if isWindowSet == true.

## ◆ getWorldSpaceCorners()

const Vector3 * Ogre::Camera::getWorldSpaceCorners | ( |  | ) | const
| overridevirtual

Gets the world space corners of the frustum.

Remarks
  The corners are ordered as follows: top-right near, top-left near, bottom-left near, bottom-right near, top-right far, top-left far, bottom-left far, bottom-right far.

Reimplemented from Ogre::Frustum.

## ◆ getWorldTransforms()

void Ogre::Camera::getWorldTransforms | ( | Matrix4 * | mat | ) | const
| overridevirtual

Overridden from Frustum/Renderable.

Implements Ogre::Renderable.

## ◆ isVisible() [1/3]

bool Ogre::Camera::isVisible | ( | const AxisAlignedBox & | bound,
|  | FrustumPlane * | culledBy = 0 ) const
| overridevirtual

Tests whether the given container is visible in the Frustum.

Parameters

  bound | Bounding box to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the box was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

## ◆ isVisible() [2/3]

bool Ogre::Camera::isVisible | ( | const Sphere & | bound,
|  | FrustumPlane * | culledBy = 0 ) const
| overridevirtual

Tests whether the given container is visible in the Frustum.

Parameters

  bound | Bounding sphere to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the sphere was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

## ◆ isVisible() [3/3]

bool Ogre::Camera::isVisible | ( | const Vector3 & | vert,
|  | FrustumPlane * | culledBy = 0 ) const
| overridevirtual

Tests whether the given vertex is visible in the Frustum.

Parameters

  vert | Vertex to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the sphere was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

## ◆ isWindowSet()

virtual bool Ogre::Camera::isWindowSet | ( |  | ) | const
| inlinevirtual

Returns if a viewport window is being used.

## ◆ lookAt() [1/2]

void Ogre::Camera::lookAt | ( | const Vector3 & | targetPoint | ) |

Points the camera at a location in worldspace.

Remarks
  This is a helper method to automatically generate the direction vector for the camera, based on it's current position and the supplied look-at point.

Parameters

  targetPoint | A vector specifying the look at point.

## ◆ lookAt() [2/2]

void Ogre::Camera::lookAt | ( | Real | x,
|  | Real | y,
|  | Real | z )

Points the camera at a location in worldspace.

Remarks
  This is a helper method to automatically generate the direction vector for the camera, based on it's current position and the supplied look-at point.

Parameters

  x | The `x` co-ordinates of the point to look at.
  y | The `y` co-ordinates of the point to look at.
  z | The `z` co-ordinates of the point to look at.

## ◆ move()

void Ogre::Camera::move | ( | const Vector3 & | vec | ) |

Moves the camera's position by the vector offset provided along world axes.

## ◆ moveRelative()

void Ogre::Camera::moveRelative | ( | const Vector3 & | vec | ) |

Moves the camera's position by the vector offset provided along it's own axes (relative to orientation).

## ◆ pitch()

void Ogre::Camera::pitch | ( | const Radian & | angle | ) |

Pitches the camera up/down anticlockwise around it's local z axis.

## ◆ projectSphere()

bool Ogre::Camera::projectSphere | ( | const Sphere & | sphere,
|  | Real * | left,
|  | Real * | top,
|  | Real * | right,
|  | Real * | bottom ) const
| overridevirtual

Project a sphere onto the near plane and get the bounding rectangle.

Parameters

  sphere | The world-space sphere to project.
  left | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  top | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  right | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  bottom | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).

Returns
  `true` if the sphere was projected to a subset of the near plane, `false` if the entire near plane was contained.

Reimplemented from Ogre::Frustum.

## ◆ removeListener()

virtual void Ogre::Camera::removeListener | ( | Listener * | l | ) |
| virtual

Remove a listener to this camera.

## ◆ resetWindow()

virtual void Ogre::Camera::resetWindow | ( |  | ) |
| virtual

Cancel view window.

## ◆ roll()

void Ogre::Camera::roll | ( | const Radian & | angle | ) |

Rolls the camera anticlockwise, around its local z axis.

## ◆ rotate() [1/2]

void Ogre::Camera::rotate | ( | const Quaternion & | q | ) |

Rotate the camera around an arbitrary axis using a Quaternion.

## ◆ rotate() [2/2]

void Ogre::Camera::rotate | ( | const Vector3 & | axis,
|  | const Radian & | angle )

Rotate the camera around an arbitrary axis.

## ◆ setAutoAspectRatio()

void Ogre::Camera::setAutoAspectRatio | ( | bool | autoratio | ) |

If set to true a viewport that owns this frustum will be able to recalculate the aspect ratio whenever the frustum is resized.

Remarks
  You should set this to true only if the frustum / camera is used by one viewport at the same time. Otherwise the aspect ratio for other viewports may be wrong.

## ◆ setAutoTracking()

void Ogre::Camera::setAutoTracking | ( | bool | enabled,
|  | SceneNode *const | target = 0,
|  | const Vector3 & | offset = Vector3::ZERO )

Enables / disables automatic tracking of a SceneNode.

Remarks
  If you enable auto-tracking, this Camera will automatically rotate to look at the target SceneNode every frame, no matter how it or SceneNode move. This is handy if you want a Camera to be focused on a single object or group of objects. Note that by default the Camera looks at the origin of the SceneNode, if you want to tweak this, e.g. if the object which is attached to this target node is quite big and you want to point the camera at a specific point on it, provide a vector in the 'offset' parameter and the camera's target point will be adjusted.

Parameters

  enabled | If true, the Camera will track the SceneNode supplied as the next parameter (cannot be null). If false the camera will cease tracking and will remain in it's current orientation.
  target | Pointer to the SceneNode which this Camera will track. Make sure you don't delete this SceneNode before turning off tracking (e.g. SceneManager::clearScene will delete it so be careful of this). Can be null if and only if the enabled param is false.
  offset | If supplied, the camera targets this point in local space of the target node instead of the origin of the target node. Good for fine tuning the look at point.

References Ogre::Vector3::ZERO.

## ◆ setCullingFrustum()

void Ogre::Camera::setCullingFrustum | ( | Frustum * | frustum | ) |
| inline

Tells the camera to use a separate Frustum instance to perform culling.

Remarks
  By calling this method, you can tell the camera to perform culling against a different frustum to it's own. This is mostly useful for debug cameras that allow you to show the culling behaviour of another camera, or a manual frustum instance.

Parameters

  frustum | Pointer to a frustum to use; this can either be a manual Frustum instance (which you can attach to scene nodes like any other MovableObject), or another camera. If you pass 0 to this method it reverts the camera to normal behaviour.

References Ogre::Frustum::Frustum().

## ◆ setDefaultSortMode()

static void Ogre::Camera::setDefaultSortMode | ( | CameraSortMode | sortMode | ) |
| inlinestatic

Sets the default sort mode for all future Camera instances.

## ◆ setDirection() [1/2]

void Ogre::Camera::setDirection | ( | const Vector3 & | vec | ) |

Sets the camera's direction vector.

## ◆ setDirection() [2/2]

void Ogre::Camera::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z )

Sets the camera's direction vector.

Remarks
  Note that the 'up' vector for the camera will automatically be recalculated based on the current 'up' vector (i.e. the roll will remain the same).

## ◆ setFixedYawAxis()

void Ogre::Camera::setFixedYawAxis | ( | bool | useFixed,
|  | const Vector3 & | fixedAxis = Vector3::UNIT_Y )

Tells the camera whether to yaw around it's own local Y axis or a fixed axis of choice.

Remarks
  This method allows you to change the yaw behaviour of the camera
  - by default, the camera yaws around a fixed Y axis. This is often what you want - for example if you're making a first-person shooter, you really don't want the yaw axis to reflect the local camera Y, because this would mean a different yaw axis if the player is looking upwards rather than when they are looking straight ahead. You can change this behaviour by calling this method, which you will want to do if you are making a completely free camera like the kind used in a flight simulator.

Parameters

  useFixed | If `true`, the axis passed in the second parameter will always be the yaw axis no matter what the camera orientation. If false, the camera yaws around the local Y.
  fixedAxis | The axis to use if the first parameter is true.

References Ogre::Vector3::UNIT_Y.

## ◆ setLightCullingVisibility()

void Ogre::Camera::setLightCullingVisibility | ( | bool | collectLights,
|  | bool | isCubemap )

When a camera is created via SceneManager::createCamera, there are two additional parameters.

Parameters

  collectLights | Tell Ogre to cull lights against this camera. This requires additional CPU power. If a camera is not going to be used for a long time (or it doesn't need lights, which is what happens with shadow mapping cameras) you want this set to false. Otherwise if you need to render and need lights, enable this setting.
  isCubemap | Use an alternative algorithm to collect lights in 360° around the camera. This is required if the camera is going to be used in passes where CompositorPassSceneDef::mCameraCubemapReorient = true; Does nothing if collectLights = false

## ◆ setLodBias()

void Ogre::Camera::setLodBias | ( | Real | factor = 1.0 | ) |

Sets the level-of-detail factor for this Camera.

Remarks
  This method can be used to influence the overall level of detail of the scenes rendered using this camera. Various elements of the scene have level-of-detail reductions to improve rendering speed at distance; this method allows you to hint to those elements that you would like to adjust the level of detail that they would normally use (up or down).

  The most common use for this method is to reduce the overall level of detail used for a secondary camera used for sub viewports like rear-view mirrors etc. Note that scene elements are at liberty to ignore this setting if they choose, this is merely a hint.

Parameters

  factor | The factor to apply to the usual level of detail calculation. Higher values increase the detail, so 2.0 doubles the normal detail and 0.5 halves it.

## ◆ setLodCamera()

virtual void Ogre::Camera::setLodCamera | ( | const Camera * | lodCam | ) |
| virtual

Set a pointer to the camera which should be used to determine LOD settings.

Remarks
  Sometimes you don't want the LOD of a render to be based on the camera that's doing the rendering, you want it to be based on a different camera. A good example is when rendering shadow maps, since they will be viewed from the perspective of another camera. Therefore this method lets you associate a different camera instance to use to determine the LOD.

  To revert the camera to determining LOD based on itself, call this method with a pointer to itself.

References Camera().

## ◆ setOrientation()

void Ogre::Camera::setOrientation | ( | const Quaternion & | q | ) |

Sets the camera's orientation.

## ◆ setPosition() [1/2]

void Ogre::Camera::setPosition | ( | const Vector3 & | vec | ) |

Sets the camera's position.

## ◆ setPosition() [2/2]

void Ogre::Camera::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z )

Sets the camera's position.

## ◆ setUseMinPixelSize()

void Ogre::Camera::setUseMinPixelSize | ( | bool | enable | ) |
| inline

Sets whether to use min display size calculations.

When active, objects that derive from MovableObject whose size on the screen is less then a MovableObject::mMinPixelSize will not be rendered.

## ◆ setUseRenderingDistance()

virtual void Ogre::Camera::setUseRenderingDistance | ( | bool | use | ) |
| inlinevirtual

Set whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.

The default behaviour is to use it.

Parameters

  use | True to use the rendering distance, false not to.

## ◆ setVrData()

void Ogre::Camera::setVrData | ( | VrData * | vrData | ) |

Sets VR data for calculating left & right eyes See OpenVR sample for more info.

Parameters

  vrData | Pointer to valid VrData This pointer must remain valid while the Camera is using it. We won't free this pointer. It is the developer's responsability to free it once no longer in use. Multiple cameras can share the same VrData pointer. The internal data hold by VrData can be changed withohut having to call setVrData again

## ◆ setWindow()

virtual void Ogre::Camera::setWindow | ( | Real | left,
|  | Real | top,
|  | Real | right,
|  | Real | bottom )
| virtual

Sets the viewing window inside of viewport.

Remarks
  This method can be used to set a subset of the viewport as the rendering target.

Parameters

  left | Relative to Viewport - 0 corresponds to left edge, 1 - to right edge (default - 0).
  top | Relative to Viewport - 0 corresponds to top edge, 1 - to bottom edge (default - 0).
  right | Relative to Viewport - 0 corresponds to left edge, 1 - to right edge (default - 1).
  bottom | Relative to Viewport - 0 corresponds to top edge, 1 - to bottom edge (default - 1).

## ◆ synchroniseBaseSettingsWith()

virtual void Ogre::Camera::synchroniseBaseSettingsWith | ( | const Camera * | cam | ) |
| virtual

Synchronise core camera settings with another.

Remarks
  Copies the position, orientation, clip distances, projection type, FOV, focal length and aspect ratio from another camera. Other settings like query flags, reflection etc are preserved.

References Camera().

## ◆ yaw()

void Ogre::Camera::yaw | ( | const Radian & | angle | ) |

Rotates the camera anticlockwise around it's local y axis.

## Member Data Documentation

## ◆ mSortMode

CameraSortMode Ogre::Camera::mSortMode

PUBLIC VARIABLE.

This variable can be altered directly. Changes are reflected immediately.

The documentation for this class was generated from the following file:

- OgreCamera.h